package sun.misc;

import java.io.PrintStream;

public class Version
{
    private static final String launcher_name = "java";
    private static final String java_version = "1.8.0_271";
    private static final String java_runtime_name = "Java(TM) SE Runtime Environment";
    private static final String java_profile_name = "";
    private static final String java_runtime_version = "1.8.0_271-b09";
    private static boolean versionsInitialized;
    private static int jvm_major_version;
    private static int jvm_minor_version;
    private static int jvm_micro_version;
    private static int jvm_update_version;
    private static int jvm_build_number;
    private static String jvm_special_version;
    private static int jdk_major_version;
    private static int jdk_minor_version;
    private static int jdk_micro_version;
    private static int jdk_update_version;
    private static int jdk_build_number;
    private static String jdk_special_version;
    private static boolean jvmVersionInfoAvailable;
    
    public Version() {
    }
    
    public static void init() {
        System.setProperty("java.version", "1.8.0_271");
        System.setProperty("java.runtime.version", "1.8.0_271-b09");
        System.setProperty("java.runtime.name", "Java(TM) SE Runtime Environment");
    }
    
    public static void print() {
        print(System.err);
    }
    
    public static void println() {
        print(System.err);
        System.err.println();
    }
    
    public static void print(PrintStream printStream) {
        boolean n = false;
        String property = System.getProperty("java.awt.headless");
        if (property != null && property.equalsIgnoreCase("true")) {
            n = true;
        }
        printStream.println("java version \"1.8.0_271\"");
        printStream.print("Java(TM) SE Runtime Environment (build 1.8.0_271-b09");
        if ("".length() > 0) {
            printStream.print(", profile ");
        }
        if ("Java(TM) SE Runtime Environment".indexOf("Embedded") != -1 && n) {
            printStream.print(", headless");
        }
        printStream.println(')');
        printStream.println(System.getProperty("java.vm.name") + " (build " + System.getProperty("java.vm.version") + ", " + System.getProperty("java.vm.info") + ")");
    }
    
    public static synchronized int jvmMajorVersion() {
        if (!Version.versionsInitialized) {
            initVersions();
        }
        return Version.jvm_major_version;
    }
    
    public static synchronized int jvmMinorVersion() {
        if (!Version.versionsInitialized) {
            initVersions();
        }
        return Version.jvm_minor_version;
    }
    
    public static synchronized int jvmMicroVersion() {
        if (!Version.versionsInitialized) {
            initVersions();
        }
        return Version.jvm_micro_version;
    }
    
    public static synchronized int jvmUpdateVersion() {
        if (!Version.versionsInitialized) {
            initVersions();
        }
        return Version.jvm_update_version;
    }
    
    public static synchronized String jvmSpecialVersion() {
        if (!Version.versionsInitialized) {
            initVersions();
        }
        if (Version.jvm_special_version == null) {
            Version.jvm_special_version = getJvmSpecialVersion();
        }
        return Version.jvm_special_version;
    }
    
    public static native String getJvmSpecialVersion();
    
    public static synchronized int jvmBuildNumber() {
        if (!Version.versionsInitialized) {
            initVersions();
        }
        return Version.jvm_build_number;
    }
    
    public static synchronized int jdkMajorVersion() {
        if (!Version.versionsInitialized) {
            initVersions();
        }
        return Version.jdk_major_version;
    }
    
    public static synchronized int jdkMinorVersion() {
        if (!Version.versionsInitialized) {
            initVersions();
        }
        return Version.jdk_minor_version;
    }
    
    public static synchronized int jdkMicroVersion() {
        if (!Version.versionsInitialized) {
            initVersions();
        }
        return Version.jdk_micro_version;
    }
    
    public static synchronized int jdkUpdateVersion() {
        if (!Version.versionsInitialized) {
            initVersions();
        }
        return Version.jdk_update_version;
    }
    
    public static synchronized String jdkSpecialVersion() {
        if (!Version.versionsInitialized) {
            initVersions();
        }
        if (Version.jdk_special_version == null) {
            Version.jdk_special_version = getJdkSpecialVersion();
        }
        return Version.jdk_special_version;
    }
    
    public static native String getJdkSpecialVersion();
    
    public static synchronized int jdkBuildNumber() {
        if (!Version.versionsInitialized) {
            initVersions();
        }
        return Version.jdk_build_number;
    }
    
    private static synchronized void initVersions() {
        if (Version.versionsInitialized) {
            return;
        }
        if (!(Version.jvmVersionInfoAvailable = getJvmVersionInfo())) {
            String property = System.getProperty("java.vm.version");
            if (property.length() >= 5 && Character.isDigit(property.charAt(0)) && property.charAt(1) == '.' && Character.isDigit(property.charAt(2)) && property.charAt(3) == '.' && Character.isDigit(property.charAt(4))) {
                Version.jvm_major_version = Character.digit(property.charAt(0), 10);
                Version.jvm_minor_version = Character.digit(property.charAt(2), 10);
                Version.jvm_micro_version = Character.digit(property.charAt(4), 10);
                CharSequence charSequence = property.subSequence(5, property.length());
                if (charSequence.charAt(0) == '_' && charSequence.length() >= 3) {
                    int n = 0;
                    if (Character.isDigit(charSequence.charAt(1)) && Character.isDigit(charSequence.charAt(2)) && Character.isDigit(charSequence.charAt(3))) {
                        n = 4;
                    }
                    else if (Character.isDigit(charSequence.charAt(1)) && Character.isDigit(charSequence.charAt(2))) {
                        n = 3;
                    }
                    try {
                        Version.jvm_update_version = (int)Integer.valueOf(charSequence.subSequence(1, n).toString());
                        if (charSequence.length() >= n + 1) {
                            int char1 = charSequence.charAt(n);
                            if (char1 >= 'a' && char1 <= 'z') {
                                Version.jvm_special_version = Character.toString((char)char1);
                                ++n;
                            }
                        }
                    }
                    catch (NumberFormatException ex) {
                        return;
                    }
                    charSequence = charSequence.subSequence(n, charSequence.length());
                }
                if (charSequence.charAt(0) == '-') {
                    String[] split = charSequence.subSequence(1, charSequence.length()).toString().split("-");
                    int length = split.length;
                    int i = 0;
                    while (i < length) {
                        String s = split[i];
                        if (s.charAt(0) == 'b' && s.length() == 3 && Character.isDigit(s.charAt(1)) && Character.isDigit(s.charAt(2))) {
                            Version.jvm_build_number = (int)Integer.valueOf(s.substring(1, 3));
                            break;
                        }
                        ++i;
                    }
                }
            }
        }
        getJdkVersionInfo();
        Version.versionsInitialized = true;
        return;
    }
    
    private static native boolean getJvmVersionInfo();
    
    private static native void getJdkVersionInfo();
    
    static {
        init();
        Version.versionsInitialized = false;
        Version.jvm_major_version = 0;
        Version.jvm_minor_version = 0;
        Version.jvm_micro_version = 0;
        Version.jvm_update_version = 0;
        Version.jvm_build_number = 0;
        Version.jvm_special_version = null;
        Version.jdk_major_version = 0;
        Version.jdk_minor_version = 0;
        Version.jdk_micro_version = 0;
        Version.jdk_update_version = 0;
        Version.jdk_build_number = 0;
        Version.jdk_special_version = null;
    }
}
